import {Component, Input, OnInit} from '@angular/core';
import {InventorySlot} from "../../../../project/game-model/inventory/intentory-slots/InventorySlot";
import {ItemGroupCharacteristic} from "../../../../project/game-model/inventory/ItemgroupCharacteristic";
import {ItemGroup} from "../../../../project/game-model/inventory/ItemGroup";
import {MatTable, MatTableDataSource} from "@angular/material/table";
import {
  InventoryCharacteristic
} from "../../../../project/game-model/inventory/intentory-slots/InventoryCharacteristic";

@Component({
  selector: 'app-inventory-slot-characteristic-editor',
  templateUrl: './inventory-slot-characteristic-editor.component.html',
  styleUrl: './inventory-slot-characteristic-editor.component.scss'
})
export class InventorySlotCharacteristicEditorComponent implements OnInit{

  @Input() inventorySlot: InventorySlot | undefined
  @Input() itemgroups: ItemGroup[] = []

  availableCharacteristics: ItemGroupCharacteristic[] = []

  datasource: MatTableDataSource<InventoryCharacteristic> = new MatTableDataSource<InventoryCharacteristic>();
  displayedColumns: string[] = ['increasing', 'decreasing', 'edit', 'delete']
  editedCharacteristic: InventoryCharacteristic | null = null;

  ngOnInit() {
    this.itemgroups.forEach(itemgroup => {
      this.availableCharacteristics = this.availableCharacteristics.concat(itemgroup.itemGroupCharacteristics);
    })
    this.datasource.data = this.inventorySlot!.slotCharacteristics;
  }

  addInventorySlotCharacteristic() {
    const slotCharacteristic = new InventoryCharacteristic(null, null);
    this.inventorySlot!.addSlotCharacteristic(slotCharacteristic);
    this.datasource.data = this.inventorySlot!.slotCharacteristics;
    this.editedCharacteristic = slotCharacteristic;
  }

  finishEditing() {
    this.editedCharacteristic = null;
  }

  onSelectIncreasingCharacteristic(selectedCharacteristic: ItemGroupCharacteristic, slotCharacteristic: InventoryCharacteristic) {
    slotCharacteristic.increasingCharacteristic = selectedCharacteristic;
  }

  onSelectDecreasingCharacteristic(selectedCharacteristic: ItemGroupCharacteristic, slotCharacteristic: InventoryCharacteristic) {
    slotCharacteristic.decreasingCharacteristic = selectedCharacteristic;
  }
}
